import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

/**
 * Solution to Contest Advancement
 * 
 * @author vanb
 */
public class contestadvancement_vanb
{
    /** Input. */
    private static Scanner sc;
    
    /** Output. */
    private static PrintStream ps;
    
    /**
     * Do it!
     */
    private void doit()
    {
        int n = sc.nextInt();
        int k = sc.nextInt();
        int c = sc.nextInt();
               
        int teams[] = new int[n];
        Arrays.fill( teams, 0 );
        
        int id[] = new int[n];
        boolean advancing[] = new boolean[n];
        Arrays.fill( advancing, false );
        
        // Rule 1: Limit the number of teams per school
        int advanced = 0;
        for( int i=0; i<n && advanced<k; i++ )
        {
            int t = sc.nextInt();
            int s = sc.nextInt()-1;
            id[i] = t;
            if( teams[s]<c ) 
            {
                advancing[i] = true;
                ++advanced;
                ++teams[s];
            }
        }
        
        // Not enough teams advanced? relax the teams-per-school rule to fill in the rest.
        for( int i=0; i<n && advanced<k; i++ )
        {
            if( !advancing[i] ) 
            {
                advancing[i] = true;
                ++advanced;
            }
        }
        
        for( int i=0; i<n; i++ ) if( advancing[i] ) ps.println( id[i] );
    }
        
    /**
     * Main.
     * 
     * @param args unused
     * @throws Exception
     */
    public static void main( String[] args ) throws Exception
    {
        sc = new Scanner( System.in );
        ps = System.out;
        
        new contestadvancement_vanb().doit();
    }

}
